context("Tests for bmass.R") 

#library("devtools"); devtools::load_all("/home/mturchin20/project/Lab_Stuff/StephensLab/bmass"); Sys.setenv(TZ='America/Chicago');
#bmass_TestData1 <- read.table("bmass_TestData1.txt", header=T)
#bmass_TestData2 <- read.table("bmass_TestData2.txt", header=T)
#bmass_TestSigSNPs <- read.table("bmass_TestSigSNPs.txt", header=T)
#load("/home/mturchin20/project/Lab_Stuff/StephensLab/bmass/data/bmass_TestData1.rda")
#load("/home/mturchin20/project/Lab_Stuff/StephensLab/bmass/data/bmass_TestData2.rda")
#load("/home/mturchin20/project/Lab_Stuff/StephensLab/bmass/data/bmass_TestSigSNPs.rda")
#DataSources <- c("bmass_TestData1", "bmass_TestData2")
#bmass_Output <- bmass(DataSources, bmass_TestSigSNPs) 
#bmass_Output2 <- bmass(DataSources, bmass_TestSigSNPs, SigmaAlphas=c(.5,.7)) 

data(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs)
DataSources <- c("bmass_TestData1", "bmass_TestData2")
bmass_TestData1 <- bmass_TestData1[bmass_TestData1$pValue > 0,]
bmass_TestData2 <- bmass_TestData2[bmass_TestData2$pValue > 0,]

assign("bmass_TestData1", bmass_TestData1, envir = .GlobalEnv)
assign("bmass_TestData2", bmass_TestData2, envir = .GlobalEnv)
assign("bmass_Output", bmass(DataSources, bmass_TestSigSNPs), envir = .GlobalEnv)
assign("bmass_Output_ZScoresCorMatrix", c(1.0000000,0.5972347,0.5972347,1.0000000), envir = .GlobalEnv)
assign("bmass_Output_GWASlogBFMinThreshold", 7.41173, envir = .GlobalEnv)
assign("bmass_Output_PreviousSNPs_SNP1", 12.53854, envir = .GlobalEnv)
assign("bmass_Output_MarginalSNPs_SNP1", 6.257912, envir = .GlobalEnv)
assign("bmass_Output2", bmass(DataSources, bmass_TestSigSNPs, SigmaAlphas=c(.5,.7)), envir = .GlobalEnv)
assign("bmass_Output2_ModelPriors_Length", 18, envir = .GlobalEnv)
assign("bmass_Output2_MarginalSNPs_logBFWAvg", c(12.218538,7.492893,5.493848), envir = .GlobalEnv)

test_that("bmass runs the main bmass function", {
	expect_equal(c(bmass_Output$ZScoresCorMatrix), bmass_Output_ZScoresCorMatrix, tolerance=1e-6)
	expect_equal(bmass_Output$GWASlogBFMinThreshold, bmass_Output_GWASlogBFMinThreshold, tolerance=1e-6)
	expect_equal(bmass_Output$PreviousSNPs$SNPs$logBFWeightedAvg[1], bmass_Output_PreviousSNPs_SNP1, tolerance=1e-6)
	expect_equal(bmass_Output$MarginalSNPs$SNPs$logBFWeightedAvg[3], bmass_Output_MarginalSNPs_SNP1, tolerance=1e-6)
	expect_equal(length(bmass_Output2$ModelPriors), bmass_Output2_ModelPriors_Length)
	expect_equal(bmass_Output2$MarginalSNPs$SNPs$logBFWeightedAvg, bmass_Output2_MarginalSNPs_logBFWAvg, tolerance=1e-6)
	expect_equal(sum(bmass_Output$MarginalSNPs$SNPs$logBFWeightedAvg) == sum(bmass_Output2$MarginalSNPs$SNPs$logBFWeightedAvg), FALSE, tolerance=1e-6)
})

rm(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs, bmass_Output, bmass_Output_ZScoresCorMatrix, bmass_Output_GWASlogBFMinThreshold, bmass_Output_PreviousSNPs_SNP1, bmass_Output_MarginalSNPs_SNP1, bmass_Output2, bmass_Output2_ModelPriors_Length, bmass_Output2_MarginalSNPs_logBFWAvg, envir = .GlobalEnv)

context("Tests for PassChecksForDataSources.R")

data(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs)
DataSources <- c("bmass_TestData1", "bmass_TestData2")
ExpectedColumnNames <- c("Chr", "BP", "A1", "MAF", "Direction", "pValue", "N") 
assign("bmass_ZeroMatrix", matrix(0, nrow=2, ncol=2), envir = .GlobalEnv)
assign("bmass_TestDirection1", data.frame(Direction=c("+","-","+")), envir = .GlobalEnv)
assign("bmass_TestDirection2", data.frame(Direction=c("+",2,"+")), envir = .GlobalEnv)
assign("bmass_TestDirection3", data.frame(Direction=c("+","-","45")), envir = .GlobalEnv)
assign("bmass_TestDirection4", data.frame(Direction=c(NA,"-","+")), envir = .GlobalEnv)

test_that("CheckCharacterClass checks whether input variable is of class character", {
	expect_equal(CheckCharacterClass("check1"), TRUE)
	expect_equal(CheckCharacterClass(""), TRUE)
	expect_equal(CheckCharacterClass(12), FALSE)
	expect_equal(CheckCharacterClass(NA), FALSE)
	expect_equal(FALSE %in% sapply(DataSources, CheckCharacterClass), FALSE)
	expect_equal(TRUE %in% sapply(DataSources, CheckCharacterClass), TRUE)
})

test_that("CheckVariableExists checks whether input variable corresponds to an object that exists", {
	expect_equal(CheckVariableExists("NoDataSet"), FALSE)
	expect_equal(CheckVariableExists("bmass_ZeroMatrix"), TRUE)
	expect_equal(CheckVariableExists("bmass_TestData1"), TRUE)
	expect_equal(FALSE %in% sapply(DataSources, CheckVariableExists), FALSE)
	expect_equal(TRUE %in% sapply(DataSources, CheckVariableExists), TRUE)
})

test_that("CheckDataFrameFormat checks whether input variable corresponds to an object of datatype data.frame", {
	expect_equal(CheckDataFrameFormat("bmass_TestData1"), TRUE)
	expect_equal(CheckDataFrameFormat("bmass_ZeroMatrix"), FALSE)	
	expect_equal(FALSE %in% sapply(DataSources, CheckDataFrameFormat), FALSE)
	expect_equal(TRUE %in% sapply(DataSources, CheckDataFrameFormat), TRUE)
})

test_that("CheckDataSourceHeaders checks whether names() of object corresponding to input variables contain all expected column headers" , {
	expect_equal(ExpectedColumnNames[1] %in% names(eval(parse(text="bmass_TestData1"))), TRUE)
	expect_equal(ExpectedColumnNames[1] %in% names(eval(parse(text="bmass_ZeroMatrix"))), FALSE)
	expect_equal(TRUE %in% CheckDataSourceHeaders(DataSources, ExpectedColumnNames), TRUE)
	expect_equal(FALSE %in% CheckDataSourceHeaders(DataSources, ExpectedColumnNames), FALSE)
	expect_equal(FALSE %in% CheckDataSourceHeaders(c(DataSources, "bmass_ZeroMatrix"), ExpectedColumnNames), TRUE)
})

test_that("CheckDataSourceDirectionColumn checks whether the \'Direction\' column in the object corresponding to the input variables only contains \'+\' or \'-\'", {
	expect_equal(CheckDataSourceDirectionColumn("bmass_TestDirection1"), TRUE)
	expect_equal(CheckDataSourceDirectionColumn("bmass_TestDirection2"), FALSE)
	expect_equal(CheckDataSourceDirectionColumn("bmass_TestDirection3"), FALSE)
	expect_equal(CheckDataSourceDirectionColumn("bmass_TestDirection4"), FALSE)
	expect_equal(FALSE %in% sapply(DataSources, CheckDataSourceDirectionColumn), FALSE)
	expect_equal(FALSE %in% sapply(c(DataSources, "bmass_TestDirection1"), CheckDataSourceDirectionColumn), FALSE)
	expect_equal(TRUE %in% sapply(c(DataSources, "bmass_TestDirection2"), CheckDataSourceDirectionColumn), TRUE)
})

rm(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs, bmass_ZeroMatrix, bmass_TestDirection1, bmass_TestDirection2, bmass_TestDirection3, bmass_TestDirection4, envir = .GlobalEnv)

context("Tests for MergeDataGWASAnnotateAndGetMarginalSNPs.R")

data(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs)
DataSources <- c("bmass_TestData1", "bmass_TestData2")
ExpectedColumnNames <- c("Chr", "BP", "A1", "MAF", "Direction", "pValue", "N") 

assign("AnnotateTest1", c(1,2,1,0,0,0,0,0,0,0,0), envir = .GlobalEnv)
assign("AnnotateTest2", c(1,0,1,0,0,0,0,0,0,0,0), envir = .GlobalEnv)
assign("ZScoreOutput1", c(-7.2004822,-1.7743819,5.9315982,2.7703272,5.3267239,5.4513104,-0.3584588,Inf,0.5100735,-2.1570727,1.6448536), envir = .GlobalEnv)
assign("ZScoreOutput2", c(-7.3487961,-0.1763742,5.8471721,2.6693421,5.0689577,5.3458374,-1.5547736,-Inf,0.4399132,-1.9514798,1.1263911), envir = .GlobalEnv)
assign("ZScoreOutput1Replace", c(-7.2004822,-1.7743819,5.9315982,2.7703272,5.3267239,5.4513104,-0.3584588,5.9315982,0.5100735,-2.1570727,1.6448536), envir = .GlobalEnv)
assign("ZScoreOutput2Replace", c(-7.3487961,-0.1763742,5.8471721,2.6693421,5.0689577,5.3458374,-1.5547736,-7.3487961,0.4399132,-1.9514798,1.1263911), envir = .GlobalEnv)

test_that("AnnotateDataWithGWASSNPs annotates input list of SNPs with a second list of GWAS SNPs", {
	expect_equal(AnnotateDataWithGWASSNPs(bmass_TestData1, bmass_TestSigSNPs), AnnotateTest1)
	expect_equal(AnnotateDataWithGWASSNPs(bmass_TestData1, bmass_TestSigSNPs, BPWindow=1), AnnotateTest2)
})

test_that("GetZScoreAndDirection extracts p-value and direction information and converts to ZScore per SNP", {
	expect_equal(apply(bmass_TestData1, 1, GetZScoreAndDirection), ZScoreOutput1)
	expect_equal(apply(bmass_TestData2, 1, GetZScoreAndDirection), ZScoreOutput2)
})

test_that("CheckForInfiniteZScores checks whether there is an infinite value among the input", {
	expect_equal(TRUE %in% sapply(ZScoreOutput1, CheckForInfiniteZScores), TRUE)
	expect_equal(TRUE %in% sapply(ZScoreOutput2[1:5], CheckForInfiniteZScores), FALSE)
})

test_that("ReplaceInfiniteZScoresWithMax replaces infinite ZScores with the maximum or minimum (as appropriate re: direction of effect) present among other ZScores", {
	expect_equal(ReplaceInfiniteZScoresWithMax(ZScoreOutput1), ZScoreOutput1Replace)
	expect_equal(ReplaceInfiniteZScoresWithMax(ZScoreOutput2), ZScoreOutput2Replace)
})

rm(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs, AnnotateTest1, AnnotateTest2, ZScoreOutput1, ZScoreOutput2, ZScoreOutput1Replace, ZScoreOutput2Replace, envir = .GlobalEnv)

context("Tests for Stephens2013PLoSONE.globallipids.GLCfuncs.R")

data(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs)
DataSources <- c("bmass_TestData1", "bmass_TestData2")
bmass_TestData1 <- bmass_TestData1[bmass_TestData1$pValue > 0,]
bmass_TestData2 <- bmass_TestData2[bmass_TestData2$pValue > 0,]

assign("bmass_TestData1", bmass_TestData1, envir = .GlobalEnv)
assign("bmass_TestData2", bmass_TestData2, envir = .GlobalEnv)
assign("bmass_Output", bmass(DataSources, bmass_TestSigSNPs), envir = .GlobalEnv)
bmass_Output_Posteriors <- bmass_Output$PreviousSNPs$Posteriors[,3:4]; bmass_Output_Posteriors[5,1] <- .45; bmass_Output_Posteriors[6,1] <- .2; bmass_Output_Posteriors[8,1] <- .35; bmass_Output_Posteriors[5,2] <- .45; bmass_Output_Posteriors[6,2] <- .35; bmass_Output_Posteriors[8,2] <- .2;
assign("bmass_Output_Posteriors", bmass_Output_Posteriors, envir = .GlobalEnv)
assign("IndepTest1",  matrix(c(1e-10,1e-7,1e-5,1e-3,.9,1,1,1,1,1,250000,200000,1,650000,25100), ncol=3, byrow=FALSE), envir = .GlobalEnv)
assign("IndepTest1_Output1", c(1,0,0,0,0), envir = .GlobalEnv)
assign("IndepTest1_Output2", c(1,0,1,1,0), envir = .GlobalEnv)
assign("IndepTest1_Normalize1", c(2.222023e-01,1.777618e-01,8.888091e-07,5.777259e-01,2.230911e-02), envir = .GlobalEnv)
assign("IndepTest1_CenteredLBF", c(0,-3,-5,-7,-9.954243), envir = .GlobalEnv)
assign("IndepTest1_PosteriorProb", c(9.979737e-01,1.995947e-03,2.993921e-05,3.991895e-07,5.544298e-10), envir = .GlobalEnv)
assign("IndepTest1_EM.PriorProbs", c(1,2e-15,3e-25,4e-35,8.467544e-50), envir = .GlobalEnv)
assign("bmass_Output_Posteriors_pIMarg", c(0.20,0.35), envir = .GlobalEnv)
assign("IndepTest1_lbfAvg", 10.30191, envir = .GlobalEnv)

test_that("indephits greedily takes top hits in a list of SNPs and removes all other SNPs within a T basepair window of them", {
	expect_equal(indephits(-log10(IndepTest1[,1]), IndepTest1[,2], IndepTest1[,3]), IndepTest1_Output1)
	expect_equal(indephits(-log10(IndepTest1[,1]), IndepTest1[,2], IndepTest1[,3], T=100000), IndepTest1_Output2)
})

test_that("normalize scales a vector by its sum", {
	expect_equal(normalize(IndepTest1[,3]), IndepTest1_Normalize1, tolerance = 1e-6)
})

test_that("centered.lbf removes max from columns of log10 Bayes Factors to avoid overflow", {
	expect_equal(centered.lbf(matrix(rep(-log10(IndepTest1[,1]), 3), ncol=3, byrow=FALSE))[,1], IndepTest1_CenteredLBF, tolerance = 1e-6)
})

test_that("posteriorprob calculates the posterior probability of the given models via an input of log10 Bayes Factors and the models' associated priors", {
	expect_equal(posteriorprob(matrix(rep(-log10(IndepTest1[,1]), 3), ncol=3, byrow=FALSE), c(2,4,6,8,10))[,1], IndepTest1_PosteriorProb, tolerance = 1e-6)
})

test_that("em.priorprobs fits a given set of model priors by repeatedly calculating posterior probabilities over a set of SNPs and using the average posterior across SNPs as the new model priors", {
	expect_equal(em.priorprobs(matrix(rep(-log10(IndepTest1[,1]), 3), ncol=3, byrow=FALSE), c(2,4,6,8,10), n=5), IndepTest1_EM.PriorProbs, tolerance = 1e-6)
})

test_that("marginal.postprobs calculates the marginal posteriors of the multivariate categories U, D, and I given a set of posterior probabilities for all models", {
	expect_equal(marginal.postprobs(bmass_Output_Posteriors, bmass_Output$Models, 1)$pI[,1], bmass_Output_Posteriors_pIMarg, tolerance = 1e-6)
})

test_that("lbf.av calculates the average log10 Bayes Factors over a set of models weighted by those models' priors", {
	expect_equal(lbf.av(matrix(rep(-log10(IndepTest1[,1]), 3), ncol=3, byrow=FALSE), c(2,4,6,8,10))[1], IndepTest1_lbfAvg, tolerance = 1e-6)
})

rm(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs, bmass_Output_Posteriors, IndepTest1, IndepTest1_Output1, IndepTest1_Output2, IndepTest1_Normalize1, IndepTest1_CenteredLBF, IndepTest1_PosteriorProb, IndepTest1_EM.PriorProbs, bmass_Output_Posteriors_pIMarg, IndepTest1_lbfAvg, envir = .GlobalEnv)

context("Tests for GetResultsFromMarginalSNPsAndFormat.R")

suppressWarnings(RNGversion("3.5.0"))
set.seed(8345)
assign("CollapseTest1", c(12,15,18), envir = .GlobalEnv)
assign("CheckOnesTest1", c(0,2,3,4,5,6,7,8,9), envir = .GlobalEnv)
assign("CheckOnesTest2", c(0,0,0,0), envir = .GlobalEnv)
assign("CheckZeroesTest1", c(1,2,3,4,5,6,7,8,9), envir = .GlobalEnv)
assign("CheckZeroesTest2", c(0,10,0,10), envir = .GlobalEnv)
assign("ModelPriors", rep(c(.5,.35,.15), 3), envir = .GlobalEnv)
assign("MarginalSNPs_logBFs_Stacked", matrix(replicate(3, sample(c(1,2,3,4,5,6,7,8,9))), nrow=9, byrow=TRUE), envir = .GlobalEnv)
assign("CollapseTest_wPriors", c(6.000000,6.544502,2.176091,2.698970,0.544068,4.217484,1.000000,1.845098,2.217484), envir = .GlobalEnv)
assign("CollapseTest_wPriors_Basic1", c(1,3,5,7,9,11), envir = .GlobalEnv)

test_that("CollapseSigmaAlphasTogether sums multiple entries of the same 'model' over different sigma_alpha hyperparameter values", {
	expect_equal(CollapseSigmaAlphasTogether(matrix(c(1,2,3,4,5,6,7,8,9), ncol=3, byrow=FALSE), 3), CollapseTest1)
})

test_that("CheckForAndReplaceOnes checks for 1 entries and replaces them with 0s", {
	expect_equal(c(apply(matrix(c(1,2,3,4,5,6,7,8,9), ncol=3, byrow=FALSE), c(1,2), CheckForAndReplaceOnes)), CheckOnesTest1)
	expect_equal(c(apply(10^matrix(0, ncol=2, nrow=2), c(1,2), CheckForAndReplaceOnes)), CheckOnesTest2) 
})

test_that("CheckForAndReplaceZeroes checks for 0 entries and replaces them with 1s", {
	expect_equal(c(apply(apply(matrix(c(1,2,3,4,5,6,7,8,9), ncol=3, byrow=FALSE), c(1,2), CheckForAndReplaceOnes), c(1,2), CheckForAndReplaceZeroes)), CheckZeroesTest1)
	expect_equal(c(apply(10^matrix(c(0,1), ncol=2, nrow=2), c(1,2), CheckForAndReplaceOnes)), CheckZeroesTest2) 
})

test_that("GetSumAcrossSigmaAlphas_withPriors sums multiple entries (in log10) of the same 'model' over different sigma_alpha hyperparameter values while multiplying each entry by that model's prior", {
	expect_equal(c(GetSumAcrossSigmaAlphas_withPriors(MarginalSNPs_logBFs_Stacked, matrix(rep(ModelPriors, ncol(MarginalSNPs_logBFs_Stacked)), nrow=length(ModelPriors), ncol=ncol(MarginalSNPs_logBFs_Stacked), byrow=FALSE), 3, 3)), CollapseTest_wPriors, tolerance=1e-6)
	expect_equal(c(matrix(c(1,2,3,4,5,6,7,8,9,10,11,12), ncol=2)[seq.int(1, by=2, length.out=3),]), CollapseTest_wPriors_Basic1) 
})

rm(CollapseTest1, CheckOnesTest1, CheckOnesTest2, CheckZeroesTest1, CheckZeroesTest2, ModelPriors, MarginalSNPs_logBFs_Stacked, CollapseTest_wPriors, CollapseTest_wPriors_Basic1, envir = .GlobalEnv)

context("Basic R Functionality")

data(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs)
DataSources <- c("bmass_TestData1", "bmass_TestData2")
ExpectedColumnNames <- c("Chr", "BP", "A1", "MAF", "Direction", "pValue", "N") 
VectorOfTrueFalse <- c(TRUE, TRUE, FALSE)
VectorOfTrue <- c(TRUE, TRUE, TRUE)
VectorOfFalse <- c(FALSE, FALSE, FALSE)
LogTest1 <- c("Test1")
LogTest2 <- matrix(c("Test1", "Test1"), nrow=2)
assign("bmass_ZeroMatrix", matrix(0, nrow=2, ncol=2), envir = .GlobalEnv)
#TestEvalParseCommands1 <- paste("Testing This With ", LogTest1, sep="")
#TestEvalParseCommands2 <- eval(parse(text=paste("Testing This With ", LogTest1, sep="")))
#eval(parse(text=paste("TestEvalParseCommands3 <- Testing This With ", LogTest1, sep="")))
assign("MergeTest1", c(6.0e-13,3.1e-02,1.0e-01,7.6e-02,3.0e-09,5.6e-03,1.0e-07,5.0e-08,7.2e-01,0.0e+00,6.1e-01,2.0e-13,5.1e-02,2.6e-01,8.6e-01,5.0e-09,7.6e-03,4.0e-07,9.0e-08,1.2e-01,0.0e+00,6.6e-01), envir = .GlobalEnv)
assign("MergeTest2", c(2.0e-13,5.1e-02,2.6e-01,8.6e-01,5.0e-09,7.6e-03,4.0e-07,9.0e-08,1.2e-01,0.0e+00,6.6e-01,6.0e-13,3.1e-02,1.0e-01,7.6e-02,3.0e-09,5.6e-03,1.0e-07,5.0e-08,7.2e-01,0.0e+00,6.1e-01), envir = .GlobalEnv)

test_that("Check basic R functionality", {
	expect_equal(is.null(NULL), TRUE)
	expect_equal(!is.null(NULL), FALSE)
	expect_equal(is.null(NA), FALSE)
	expect_equal(is.na(NA), TRUE)
	expect_equal(is.na(435), FALSE)
	expect_equal(is.numeric(13), TRUE)
	expect_equal(is.numeric("ah"), FALSE)
	expect_equal(is.numeric(NA), FALSE)
	expect_equal(is.character("3"), TRUE)
	expect_equal(is.character(3), FALSE)
	expect_equal(is.character(NA), FALSE)
	expect_equal(is.vector(c(1,2,3)), TRUE)
	expect_equal(is.vector("2"), TRUE)
	expect_equal(is.vector(matrix(0, nrow=2, ncol=2)), FALSE)
	expect_equal(length(c(1,2,3,4,5,6,7,8,9)) != length(c(1,2)), TRUE)
	expect_equal(length(c(1,2,3,4,5,6,7,8,9)) == 3^length(c(1,2)), TRUE)
	expect_equal(length(ExpectedColumnNames) != length(DataSources), TRUE)
	expect_equal(length(ExpectedColumnNames) != 3^length(DataSources), TRUE)
	expect_equal(length(c(1,2,3,4,5,6,7,8,9)[c(1,2,3,4,5,6,7,8,9)>5]) == 4, TRUE)

	expect_error(stop("StopMessage"), "StopMessage")
	expect_error(stop(paste(LogTest1, "StopMessage", sep="")), "Test1StopMessage")
	expect_error(stop(paste(DataSources, sep=" ")), "bmass_TestData1bmass_TestData2")
	expect_error(stop(paste(DataSources, collapse=" ")), "bmass_TestData1 bmass_TestData2")

	expect_equal(eval(parse(text="bmass_TestData1")), bmass_TestData1)
	expect_equal(eval(parse(text=paste("bmass_TestData1", "$Direction", sep=""))), bmass_TestData1$Direction)
	expect_equal(eval(parse(text=paste("bmass_TestData1", "$Direction", sep="")))[eval(parse(text=paste("bmass_TestData1", "$Direction", sep=""))) == "+"], bmass_TestData1$Direction[bmass_TestData1$Direction == "+"])
#	expect_equal(TestEvalParseCommands1, TestEvalParseCommands2)
#	expect_equal(TestEvalParseCommands1, TestEvalParseCommands3)
#	expect_equal(TestEvalParseCommands2, TestEvalParseCommands3)
})

test_that("DataSources is of datatype vector", {
	expect_equal(is.vector(DataSources), TRUE)
	expect_equal(!is.vector(DataSources), FALSE)
})

test_that("Check %in% functionality regarding TRUE/FALSE vectors", {
	expect_equal(TRUE %in% VectorOfTrue, TRUE)
	expect_equal(FALSE %in% VectorOfTrue, FALSE)
	expect_equal(FALSE %in% VectorOfFalse, TRUE)
	expect_equal(TRUE %in% VectorOfFalse, FALSE)
	expect_equal(TRUE %in% VectorOfTrueFalse, TRUE)
	expect_equal(FALSE %in% VectorOfTrueFalse, TRUE)
})

test_that("Check merge() functionality", {
	expect_equal(c(matrix(unlist(merge(bmass_TestData1[,c("Marker", "pValue")], bmass_TestData2[,c("Marker", "pValue")], by="Marker")[,2:3]))), MergeTest1, tolerance = 1e-6)
	expect_equal(c(matrix(unlist(merge(bmass_TestData2[,c("Marker", "pValue")], bmass_TestData1[,c("Marker", "pValue")], by="Marker")[,2:3]))), MergeTest2, tolerance = 1e-6)
})

test_that("Check basic LogFile functionality works", {
	expect_equal(matrix(rbind(LogTest1, LogTest1)), LogTest2)
})

rm(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs, bmass_ZeroMatrix, MergeTest1, MergeTest2, envir = .GlobalEnv)

context("Tests for ResultsFollowupAnalysisAndPlotting.R")

data(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs)
DataSources <- c("bmass_TestData1", "bmass_TestData2")
bmass_TestData1 <- bmass_TestData1[bmass_TestData1$pValue > 0,]
bmass_TestData2 <- bmass_TestData2[bmass_TestData2$pValue > 0,]

assign("bmass_TestData1", bmass_TestData1, envir = .GlobalEnv)
assign("bmass_TestData2", bmass_TestData2, envir = .GlobalEnv)
assign("bmass_Output", bmass(DataSources, bmass_TestSigSNPs), envir = .GlobalEnv)
assign("bmass_Output_MdlPrMtrx1", c(5,8,6,1,2,3,4,7,9), envir = .GlobalEnv)
assign("bmass_Output_TopModel1", 2, envir = .GlobalEnv)
assign("bmass_Output_Marg_pI", c(7.404466e-157,3.359480e-145,3.099810e-156,6.197017e-144), envir = .GlobalEnv) 

test_that("GetModelPriorMatrix creates a matrix describing the original models and their associated trained priors", {
	expect_equal(GetModelPriorMatrix(DataSources, bmass_Output$Models, bmass_Output$ModelPriors, bmass_Output$LogFile)$ModelPriorMatrix$OrigOrder, bmass_Output_MdlPrMtrx1)	
})

test_that("GetTopModelsPerSNPViaPosteriors gets the top multivariate models per SNP based on each model's posterior probability", {
	expect_equal(as.numeric(GetTopModelsPerSNPViaPosteriors(DataSources, bmass_Output$PreviousSNPs, GetModelPriorMatrix(DataSources, bmass_Output$Models, bmass_Output$ModelPriors, bmass_Output$LogFile)$ModelPriorMatrix, bmass_Output$LogFile)$ListSNPs$TopModels[,2]), bmass_Output_TopModel1)
})

test_that("GetMarginalPosteriors gets the marginal posteriors for the U, D, and I multivariate categories for each SNP", {
	expect_equal(c(GetMarginalPosteriors(DataSources, bmass_Output$PreviousSNPs, bmass_Output$Models, bmass_Output$LogFile)$ListSNPs$Marginals$pI), bmass_Output_Marg_pI)
})

rm(bmass_TestData1, bmass_TestData2, bmass_TestSigSNPs, bmass_Output, bmass_Output_MdlPrMtrx1, bmass_Output_TopModel1, bmass_Output_Marg_pI, envir = .GlobalEnv)
